/*
iadn
http://www.iadn.narod.ru
iadn@bk.ru
*/

#include<menuet/os.h>
#include <kosgl.h> //TinyGL
#include <string.h>
#include <math.h>

#include "SysCall.h"
#include "ProcessTab.h"

int Fps (long x, long y);
extern "C"{
void app_main(void);
}

struct {
	   int x,y;
	   int dx,dy;
	   } win;

#define KEY_ESC       1
#define KEY_F     	 33

char *title1 = "TinyGL in KolibriOS";
char *title2 = "F full screen";
char *title3 = "ESC - exit";
char *fps    = "FPS:";

unsigned char FullScreen = 0;
unsigned char skin = 3;

process_table_entry_* pri;
KOSGLContext cgl;

GLfloat lightpos[4] = {2.0, 0.0, -2.5, 1.0};
GLfloat lightdirect[3] = {-0.0, -0.0, -0.7};

float angle = 0.0;
float dangle = 0.0;

char logo[10][41] ={
	 			  {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
	 			  {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
	 			  
	 			  {0,0,1,0,0,0,1,0,0,0,0,0,0,1,0,1,0,1,0,0,0,0,1,0,1,0,1,0,0,1,1,1,0,0,0,1,1,1,0,0,0},
	 			  {0,0,1,0,0,1,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,1,1,0,0,0,0,1,0,0,0,1,0,1,0,0,0,1,0,0},
	 			  {0,0,1,0,1,0,0,0,0,1,1,0,0,1,0,1,0,1,1,1,0,0,1,0,0,0,1,0,1,0,0,0,1,0,0,1,1,0,0,0,0},
	 			  {0,0,1,1,1,0,0,0,1,0,0,1,0,1,0,1,0,1,0,0,1,0,1,0,0,0,1,0,1,0,0,0,1,0,0,0,0,1,0,0,0},
	 			  {0,0,1,0,0,1,0,0,1,0,0,1,0,1,0,1,0,1,0,0,1,0,1,0,0,0,1,0,1,0,0,0,1,0,1,0,0,0,1,0,0},
	 			  {0,0,1,0,0,0,1,0,0,1,1,0,0,1,0,1,0,0,1,1,0,0,1,0,0,0,1,0,0,1,1,1,0,0,0,1,1,1,0,0,0},
	 			  
	 			  {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
	 			  {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
	 			  };

void DrawGL() 
{
  float z;
    
  glLoadIdentity();
  glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  glTranslatef(0.0, 0.0, -2.0);            

    glRotatef(10.0, 0.0, 0.0, 1.0);
	glRotatef(43.0, 0.0, 1.0, 0.0);
    glTranslatef(-0.6, -0.2, -0.1);
	
	for(int i=0;i<41;i++){	
	glTranslatef(0.045, 0.0, 0.0);
	glPushMatrix();
	z = 0.08*sin(angle);
	angle += 0.2;
    
    for(int j=9;j>=0;j--){
	if(logo[j][i])	glColor3f(1.0, 0.0, 0.0);
	else glColor3f(0.859, 0.855, 0.945);	
	glTranslatef(0.0, 0.045, 0.0);		
	glBegin(GL_QUADS); // 
	  glVertex3f(0.0,  -0.04, z);
	  glVertex3f(0.04, -0.04, z);
	  glVertex3f(0.04,  0.0, z);
	  glVertex3f(0.0, 0.0, z);
    glEnd();	
	}
	glPopMatrix();
	}
	
	angle = dangle;
    
 kosglSwapBuffers(); 
} 

void reshape()
{     
   __menuet__get_process_table((process_table_entry*)pri,-1);
   glViewport(0, 0, pri->winx_size, pri->winy_size-20);
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   gluPerspective(28.0, (GLfloat)pri->winx_size/pri->winy_size, 1.0, 40.0);
   glMatrixMode(GL_MODELVIEW);
   glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );     
}

void disabletgl()
{
	kosglDestroyContext(cgl); 
	delete pri;
}

void Title()
{
     __menuet__write_text(300,8,0x10ffffff,fps,strlen(fps));
     __menuet__write_text(8,8,0x10ffffff,title1,strlen(title1));
	 __menuet__write_text(180,8,0x00ffffff,title2,strlen(title2));
     __menuet__write_text(600,8,0x00ffffff,title3,strlen(title3));
}

void draw_window(void)
{
	// start redraw
	__menuet__window_redraw(1);
	// define&draw window
	__menuet__define_window(win.x,win.y,win.dx,win.dy,TYPEWIN(0,0,0,1,skin,0,0,0),0,0);
    // end redraw
    __menuet__window_redraw(2);
    // display string
    Title();
}

void app_main(void)          
{ 	 
  win.x = 100;
  win.y = 100;
  win.dx = 400;
  win.dy = 300;

  draw_window();

  cgl = kosglCreateContext( 0, 0);
  kosglMakeCurrent( 0, 20, win.dx, win.dy-20, cgl);

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();

  glClearColor ( 140.0/255.0, 140.0/255.0, 150.0/255.0, 1.0);
  
  glEnable(GL_LIGHTING);
  glLightf(GL_LIGHT0, GL_SPOT_EXPONENT, 0.0);
  glLightf(GL_LIGHT0, GL_SPOT_CUTOFF, 180.0);
  glEnable(GL_LIGHT0);

  glLightfv(GL_LIGHT0, GL_POSITION, lightpos);
  glLightfv(GL_LIGHT0, GL_SPOT_DIRECTION, lightdirect);

  glEnable(GL_COLOR_MATERIAL);
  
  glClearDepth(1.0);
  glEnable( GL_CULL_FACE );
  glEnable(GL_DEPTH_TEST);

  pri=new process_table_entry_;
  SysCall(66,1,1);
  
  reshape();
  
do{
 
 DrawGL();
 
 dangle -= 0.01*Fps (335,8);
  				
		  switch(__menuet__check_for_event())
		      {
		          case 1: draw_window();				  	   	  
				  	   	  reshape();
				  	   	  break;
		          case 2: 		          
		          	   switch(__menuet__getkey()){

						   case KEY_F:
                                    if(!FullScreen){									 
									 skin=0;
									 SysCall(67,0,0,SysCall(14)>>16,SysCall(14)&0xffff);
									 draw_window();
									 reshape();
									 FullScreen = 1;
									}
									else{
									 skin=3;
									 draw_window();
									 SysCall(67,win.x,win.y,win.dx,win.dy);
									 reshape();
									 FullScreen = 0;
									};
						  			break;
		          
                           case KEY_ESC: disabletgl();
						  				 return;}
						  				 break;
						  			
			  	  case 3: disabletgl();
						  return;
		      }
}while(1);
}
